"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var test_utils_1 = require("../../utils/test-utils");
var UserEntity_1 = require("./entity/UserEntity");
var UserToOrganizationEntity_1 = require("./entity/UserToOrganizationEntity");
var OrganizationEntity_1 = require("./entity/OrganizationEntity");
describe("github issues > #1703 Many to Many with association table returns odd values.", function () {
    var connections;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, test_utils_1.createTestingConnections({
                        entities: [__dirname + "/entity/*{.js,.ts}"],
                        enabledDrivers: ["mysql"]
                    })];
                case 1: return [2 /*return*/, connections = _a.sent()];
            }
        });
    }); });
    beforeEach(function () { return test_utils_1.reloadTestingDatabases(connections); });
    after(function () { return test_utils_1.closeTestingConnections(connections); });
    it("should work as expected", function () { return Promise.all(connections.map(function (connection) { return __awaiter(_this, void 0, void 0, function () {
        var user1, user2, user3, organization1, organization2, organization3, userOrganization1, userOrganization2, userOrganization3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    user1 = new UserEntity_1.UserEntity();
                    user2 = new UserEntity_1.UserEntity();
                    user3 = new UserEntity_1.UserEntity();
                    return [4 /*yield*/, connection.manager.save(user1)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, connection.manager.save(user2)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, connection.manager.save(user3)];
                case 3:
                    _a.sent();
                    organization1 = new OrganizationEntity_1.OrganizationEntity();
                    organization2 = new OrganizationEntity_1.OrganizationEntity();
                    organization3 = new OrganizationEntity_1.OrganizationEntity();
                    return [4 /*yield*/, connection.manager.save(organization1)];
                case 4:
                    _a.sent();
                    return [4 /*yield*/, connection.manager.save(organization2)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, connection.manager.save(organization3)];
                case 6:
                    _a.sent();
                    userOrganization1 = new UserToOrganizationEntity_1.UserToOrganizationEntity();
                    userOrganization1.role = "owner";
                    userOrganization1.user = user1;
                    userOrganization1.organization = organization1;
                    return [4 /*yield*/, connection.manager.save(userOrganization1)];
                case 7:
                    _a.sent();
                    userOrganization2 = new UserToOrganizationEntity_1.UserToOrganizationEntity();
                    userOrganization2.role = "owner";
                    userOrganization2.user = user2;
                    userOrganization2.organization = organization2;
                    return [4 /*yield*/, connection.manager.save(userOrganization2)];
                case 8:
                    _a.sent();
                    userOrganization3 = new UserToOrganizationEntity_1.UserToOrganizationEntity();
                    userOrganization3.role = "owner";
                    userOrganization3.user = user2;
                    userOrganization3.organization = organization3;
                    return [4 /*yield*/, connection.manager.save(userOrganization3)];
                case 9:
                    _a.sent();
                    return [4 /*yield*/, connection.manager
                            .createQueryBuilder(OrganizationEntity_1.OrganizationEntity, "organization")
                            .leftJoinAndSelect("organization.users", "users")
                            .getMany()];
                case 10:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); })); });
});
//# sourceMappingURL=issue-1703.js.map